package scimark2;

/*****************************************************************************
 Main benchmark driver
 *****************************************************************************/


public class applet implements jnt.Bench.Target
{

  public double[] execute(jnt.Bench.Bench b)
  {
		double res[] = new double[6];
		Random R = new Random(Constants.RANDOM_SEED);
		double resolution_time =  Constants.RESOLUTION_DEFAULT;

		b.noteStatus("benchmarking FFT");
		res[1] = kernel.measureFFT( Constants.FFT_SIZE, resolution_time, R);

		b.noteStatus("benchmarking SOR");
		res[2] = kernel.measureSOR( Constants.SOR_SIZE, resolution_time, R);

		b.noteStatus("measuring Monte Carlo");
		res[3] = kernel.measureMonteCarlo(resolution_time, R);
		res[4] = kernel.measureSparseMatmult( Constants.SPARSE_SIZE_M, 
						Constants.SPARSE_SIZE_M, Constants.SPARSE_SIZE_nz, 
						resolution_time, R);

		b.noteStatus("measuring LU factorization");
		res[5] = kernel.measureLU( Constants.LU_SIZE, resolution_time, R);

		res[0] = (res[1] + res[2] + res[3] + res[4] + res[5]) / 5;


		return res;
	}
}

